#include <stdlib.h>
#include <string.h>
#include <dos.h>
/*uses ATIVW.C*/
#include "ativw.h"

/*
This a standard autodetect function as outlines in the Turbo C Manual.
If the card is detected, the highest available mode number is returned.
Otherwise a negative number indicating an error is returned.


copyright(c) 1990 by Peter F. Jones. ALL RIGHTS RESERVED.
This software may be used and included in other programs as
outlined in your software license.
*/

char   copyrightATI256[] = "copyright(c) 1990 by Peter F. Jones. ALL RIGHTS RESERVED.";








int huge detect_ATI_VGA_Wonder_256()
    {
     int   counter;
     char  manufacturer_id[] = "761295520";
     char  chip_set_id[] =     "31";
     char far  *manufacturer;
     char far  *chip_set;
     unsigned char  found;

	found = 1;
	manufacturer = MK_FP(0xC000,0x0031);
	chip_set     = MK_FP(0xC000,0x0040);

	for(counter=0;counter<9;counter++)
	  if (manufacturer[counter]!=manufacturer_id[counter]) found = 0;

	if (found)
	for(counter=0;counter<2;counter++)
	  if (chip_set[counter]!=chip_set_id[counter]) found = 0;

      if (!found) return(-11);    /* graphics error - no ATI Wonder */

      	     if (ATI_test_bios_mode(0x64))  /*check 1024x768*/
		  {
		     return(4);
		  };


	     if (ATI_test_bios_mode(0x63))  /*check 800x600*/
		  {
		     return(3);
		  };

	     if (ATI_test_bios_mode(0x62))  /*check 640x480*/
		 {
		     return(2);
		  };

	     if (ATI_test_bios_mode(0x61))  /*check 640x400*/
		  {
		     return(1);
		  };

	     if (ATI_test_bios_mode(0x13))   /*check 320x200*/
		  {
		     return(0);
		  };
       };

