// Copyright 1991 (c),   Lake View Software
//                       4321 Harborough Rd.
//                       Columbus, OH 43220
// LVS Windows Library
// br.cpp

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "lvswin.hpp"
#include "lvsmenu.hpp"
#include "lvs_prn.hpp"
#include "pxengine.h"
#include "br.hpp"


TABLEHANDLE  tblHandle = 0;
RECORDHANDLE recHandle = 0;
RECORDNUMBER recs;
int flds;
int keys;

char *NAME = " Paradox Table Browser v2.0 ";

void main (int argv, char **argc)
{
    if (argv != 1)
        Parse_Commands (argv, argc);

	if (Error (PXInit ()))
		exit (1);

    VGA_setblink (W_OFF);
    VGA_fontload ();
    Win_DesqView_Aware ();

    WinObj Main_Scr;
	Main_Scr.open (1, 0, 23, 79, W_NOBORDER, _BLACK|LGREY);
	Main_Scr.set_fill ('');
	Main_Scr.clr_win ();

    WinObj Logo;

    Logo.open (8, 26, 14, 53, W_NOBORDER, _BLACK|LCYAN);
    Logo.center (1, NAME);
    Logo.set_attr (_BLACK|WHITE);
    Logo.center (3, "Copyright (c) 1991");
    Logo.set_attr (_BLACK|DGREY);
    Logo.center (4, "by");
    Logo.set_attr (_BLACK|BLUE);
    Logo.center (5, "Lake View Software");

    // Init mouse driver
    Win_mouse_mode (M_FULL);

	Main_Menu ();

	PXExit ();
}

static void About ()
{
    WinObj w;

    w.open (3, 15, 14, 65, W_SINGLE, _BLACK|LBLUE, _BLACK|WHITE);
    w.shadow ();
    w.title (NAME);

    w.puts (3, 6, "LVS Windows from Lake View Software");
    w.set_attr (_BLACK|LGREY);
    w.puts (1, 1, "BR was written using:");
    w.set_attr (_BLACK|CYAN);
    w.puts (5, 6, "Paradox Engine from Borland International");
    w.set_attr (_BLACK|WHITE);
    w.puts (7, 6, "Borland C++ from Borland International");
    w.get_key (W_NOECHO, 25);
}

void Open_Menu (WinMenu *m)
{
	m->open (0, 0, 0, 79, W_NOBORDER, _LGREY|BLACK);
	m->message_line (24);
	m->set_keyattr (_LGREY|RED);
	m->set_barattr (_RED|WHITE);

    static WinMenu t;
    t.message_line (24);
    t.hide ();
    t.shadow ();
    t.set_type (MENU_SUB);
	t.set_keyattr (_LGREY|RED);
    t.open (1, 0, 6, 9, W_SINGLE, _LGREY|BLACK, _LGREY|BLUE);
    t.prompt (0, 0, 11, " Open   ", "Open a table", 'O');
    t.prompt (1, 0, 12, " Close  ", "Close the current table", 'C');
    t.prompt (2, 0, 13, " Browse ", "Browse a table", 'B');
    t.prompt (3, 0, 14, " New    ", "Create a new table", 'N');

    static WinMenu s;
    s.message_line (24);
    s.hide ();
    s.shadow ();
    s.set_type (MENU_SUB);
    s.set_keyattr (_LGREY|RED);
    s.open (1, 11, 5, 21, W_SINGLE, _LGREY|BLACK, _LGREY|BLUE);
    s.prompt (0, 0, 21, " Print   ", "Print the current table structure", 'P');
    s.prompt (1, 0, 22, " Encrypt ", "Encrypt a table", 'E');
    s.prompt (2, 0, 23, " Decrypt ", "Decrypt a table", 'D');

	m->prompt (0,  0,  &t, " Table ", "Open, Close, Browse, New", 'T');
    m->prompt (0, 11,  &s, " Structure ", "Print, Encrypt, Decrypt", 'S');
	m->prompt (0, 25,  3, " System ", "Shell to DOS", 'y');
    m->prompt (0, 36,  4, " About ", "About this browser", 'A');
    m->prompt (0, 45,  0, " Quit ",   "Quit to DOS", 'Q');
}

void Main_Menu ()
{
	WinMenu m;

    Open_Menu (&m);

	int choice = -1;
	while (choice)
		{
        Say_Wait (0);
		choice = m.read (choice);

		switch (choice)
			{
			case 3:
				clrscr ();
				puts ("type 'EXIT' to return\n\n");
				system ("");
				clrscr ();
				m.update_all ();        // restore the screen
				break;

            case 4:
                About ();
                break;

            case 11:
	    		Table_Open ();
                break;
    		case 12:
	    		Table_Close ();
                break;
            case 23:
                Table_Decrypt ();
                break;
            case 22:
                Table_Encrypt ();
                break;
    		case 14:
	    		New_Table ();
		    	break;
            case 13:
                m.hide_chain ();
                Browse ();
                break;
            case 21:
                Print_Struct ();
                break;
			}
		}
}

void Table_Decrypt ()
{
    if (tblHandle)
        Table_Close ();

    Win_File_List wl;
    wl.set_attr (_CYAN|WHITE);
    wl.change_border (W_SINGLE, _CYAN|BLACK);

	char *file = wl.read ("*.DB");

    if (!file)
        return;

    WinObj w;
    w.open (5, 10, 7, 40, W_SINGLE,  _GREEN|BLACK);
    w.shadow ();
    w.title (" Decrypt Table ");
    w.printf (" Password: ");
    static char password[16] = "";
    w.get (0, w.wherex (), password, 'A', 15);
    if (w.read () == ESC)
        return;

    Say_Wait (1);
    if (Error (PXPswAdd (password)))
        return;
    Error (PXTblDecrypt (file));
    Error (PXPswDel (password));
}

void Table_Encrypt ()
{
    if (tblHandle)
        Table_Close ();

    Win_File_List wl;
    wl.set_attr (_CYAN|WHITE);
    wl.change_border (W_SINGLE, _CYAN|BLACK);

	char *file = wl.read ("*.DB");
    if (!file)
        return;

    WinObj w;
    w.open (5, 10, 7, 40, W_SINGLE,  _GREEN|BLACK);
    w.shadow ();
    w.title (" Encrypt Table ");
    w.printf (" Password: ");
    static char password[16] = "";
    w.get (0, w.wherex (), password, 'A', 15);
    if (w.read () == ESC)
        return;

    Say_Wait (1);
    Error (PXTblEncrypt (file, password));
}

void Table_Open ()
{
    Win_File_List wl;
    wl.set_attr (_CYAN|WHITE);
    wl.change_border (W_SINGLE, _CYAN|BLACK);

	char *file = wl.read ("*.DB");

	if (!file)
        return;
	if (tblHandle)
		Table_Close ();

    int Protected;
    if (Error (PXTblProtected (file, &Protected)))
        return;
    if (Protected)
        {
        WinObj w;
        w.open (5, 10, 7, 40, W_SINGLE, _GREEN|BLACK);
        w.shadow ();
        w.title (" Table has Password ");
        w.printf (" Password: ");
        static char password[16] = "";
        if (password[0])
            PXPswDel (password);
        w.get (0, w.wherex (), password, 'A', 15);
        if (w.read () == ESC)
            return;
        if (Error (PXPswAdd (password)))
            return;
        }

	if (!Error (PXTblOpen (file, &tblHandle, 0, 1)))
		Error (PXRecBufOpen (tblHandle, &recHandle));

	Show_Status ();
	Show_Struct ();			// Open and display structure window
}

void Table_Close ()
{
	if (!tblHandle)
		return;

	Error (PXTblClose (tblHandle));

	tblHandle = 0;
	Show_Status ();
	Show_Struct ();				// Close structure window
}

static WinObj s;

void Show_Struct ()
{
	if (!tblHandle )
		{
		s.close ();
		return;
		}

	s.set_virtual (flds+1, 0);
	int height = flds;
	if (height > 18)
		height = 18;
	s.open (1, 39, 3 + height, 78, W_DOUSIN, _CYAN|RED, _CYAN|BLUE);
    s.shadow ();
	s.title (" Table Structure ");

	s.printf (0, 6, "Field");
	s.printf (0, 32, "Type");
	s.set_attr (_CYAN|BLACK);
	for (unsigned i=1; i<=flds; i++)
		{
        s.printf (i, 0, "%3d.", i);

		char str [26];
		Error (PXFldName (tblHandle, i, 26, str));
		s.printf (i, 6, str);

		Error (PXFldType (tblHandle, i, 26, str));
		s.printf (i, 32, str);
		}
}

void Print_Struct ()
{
	if (!tblHandle )
		return;

    if (!Win_Get_YN ("Printer ready (y/n)"))
        return;

	Win_Prn p;

	int height = flds + 5;
	if (height < 66)
		height = 66;

    p.set_virtual (height, 80);

    if (p.open () != W_OK)
        {
        Win_Error ("Printer open error");
        return;
        }

    char name[100];
	if (Error (PXTblName (tblHandle, 100, name)))
		return;
    p.printf (0, 2, "Structure for: %s", name);

	p.puts (3, 8, "Field Name");
    p.puts (4, 8, "-------------------------");
	p.puts (3, 34, "Type");
    p.puts (4, 34, "-----");

	for (unsigned i=1; i<=flds; i++)
		{
        p.printf (i + 4, 2, "%3d.", i);

		char str [26];
		Error (PXFldName (tblHandle, i, 26, str));
		p.puts (i + 4, 8, str);

		Error (PXFldType (tblHandle, i, 26, str));
		p.puts (i + 4, 34, str);
		}

    p.print_page ();
}

static WinObj st;
void Show_Status ()
{
	if (!st.is_open ())
		st.open (23, 0, 23, 79, W_NOBORDER, _LGREY|BLACK);

	st.clr_win ();

	if (!tblHandle)
		return;

	char name [100];

	if (Error (PXTblName (tblHandle, 100, name)))
		return;

	st.printf (0, 1, name);

	Error (PXTblNRecs (tblHandle, &recs));
	Error (PXKeyNFlds (tblHandle, &keys));
	Error (PXRecNFlds (tblHandle, &flds));

	st.printf ("    -- %ld Recs,  %d Flds,  %d Flds in Key --",
			recs, flds, keys);
}


int Error(int rc)
{
	if (rc != PXSUCCESS)
		{
		WinObj w;
		char *str = PXErrMsg (rc);
		Win_Error (str);
		}
	return rc;
}
