// Copyright 1991 (c),   Lake View Software
//                       4321 Harborough Rd.
//                       Columbus, OH 43220
// LVS Windows Library
// browse.cpp

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "lvswin.hpp"
#include "LVSmenu.hpp"
#include "pxengine.h"
#include <ctype.h>
#include <string.h>
#include "br.hpp"

void Browse ()
{
    if (!tblHandle)
        Table_Open ();

	if (!tblHandle)
		return;

	WinObj b;
	WinMenu m;
    int key, choice = 1;


	m.open (0, 0, 0, 79, W_NOBORDER, _LGREY|BLACK);
	m.message_line (24);
	m.set_keyattr (_LGREY|RED);
	m.set_barattr (_RED|WHITE);

	m.prompt (0,  0,  1, " Add ", "Add a new record", 'A');
	m.prompt (0,  7,  2, " Change ", "Change the current record", 'C');
	m.prompt (0, 17,  3, " Delete ", "Delete the current record", 'D');
	m.prompt (0, 27,  4, " Next ", "Next record", 'N');
	m.prompt (0, 35,  5, " Previous ", "Previous record", 'P');
	m.prompt (0, 47,  6, " Retrieve ", "Retrieve a record", 'R');
	m.prompt (0, 59,  0, " Quit ", "Return to main menu", 'Q');

	/*
	 * Find longest field
	 */
	int longest = Longest_Field (tblHandle, flds);

	b.set_virtual (flds, longest+27);
	int x = 2 + 27 + longest;
	if (x > 75)
		x = 75;
	int y = 3 + flds;
	if (y > 22)
		 y = 22;


	b.open (23 - y, 1, 21, x, W_DOUSIN, _BLUE|WHITE, _BLUE|CYAN);
	b.shadow ();
	b.title (" Browse ");

	Display_Field_Names (tblHandle, flds, b);
	b.gotoxy ();
	Error (PXRecFirst (tblHandle));         // point to first record
	b.PXrecord (tblHandle, recHandle);

	for (;;)
		{
        RECORDNUMBER rec_cnt;
        if (Error (PXTblNRecs (tblHandle, &rec_cnt)))
            break;
        if (rec_cnt)
            Error (PXRecGet (tblHandle, recHandle));
        else
            Error (PXRecBufEmpty (recHandle));

   	    Display_Data (flds, b);
   		b.set_pan (0, 0);
        b.clear_gets ();

        Show_Status ();
        Say_Wait (0);
        choice = m.read (choice);

        if (choice == W_ESCAPE || choice == 0)
            break;

        Say_Wait (1);

        switch (choice)
            {
            case 1:     // Add
                if (Error (PXRecBufEmpty (recHandle)))
                    break;
        		Display_Data (flds, b);
        		b.set_pan (0, 0);
        		Say_Wait (0);
        		key = b.PXread ();
    		    /*
    	    	 * Add the record if the user made a change
	    	     */
		        if (b.any_read_change () && key != ESC)
                    if (Win_Get_YN ("Save new record (y/n)"))
            			Error (PXRecAppend (tblHandle, recHandle));
                break;

            case 2:     // change
                if (!rec_cnt)               // no records
                    break;
        		Display_Data (flds, b);
        		b.set_pan (0, 0);
        		Say_Wait (0);
        		key = b.PXread ();
    		    /*
    	    	 * Update the record if the user made a change
	    	     */
		        if (b.any_read_change () && key != ESC)
                    if (Win_Get_YN ("Save changes (y/n)"))
            			Error (PXRecUpdate (tblHandle, recHandle));
                break;

            case 3:     // delete
                Say_Wait (0);
                if (Win_Get_YN ("Delete current record (y/n)"))
                    Error (PXRecDelete (tblHandle));
                break;

            case 4:     // Next
				Error (PXRecNext (tblHandle));
                break;

            case 5:     // Prev
				Error (PXRecPrev (tblHandle));
                break;

            case 6:     // Retrieve
                if (Error (PXRecBufEmpty (recHandle)))
                    break;
                Display_Data (flds, b);
                b.clear_gets ();
            	for (unsigned ui=1; ui <= keys; ui++)
            		b.PXget (ui-1, 27, ui);
        		b.set_pan (0, 0);
        		Say_Wait (0);
        		key = b.PXread ();
    		    /*
    	    	 * Add the record if the user made a change
	    	     */
		        if (b.any_read_change () && key != ESC)
                    Error (PXSrchKey(tblHandle, recHandle, keys, 
                            SEARCHFIRST | CLOSESTRECORD));
                break;
            }
		}
}

void Display_Data (int flds, WinObj &w)
{
	for (unsigned i=1; i <= flds; i++)
		w.PXget (i-1, 27, i);
}

void Display_Field_Names (TABLEHANDLE tblHandle, int flds, WinObj &w)
{
	char str [26];
	for (unsigned i=1; i <= flds; i++)
		{
		Error (PXFldName (tblHandle, i, 26, str));
		w.printf (i-1, 25-strlen (str) , "%s:", str);
		}
}

int Longest_Field (TABLEHANDLE tblHandle, int flds)
{
	char fld_type [10];
	int longest = 0;
	int temp=0;
	for (unsigned i=1; i <= flds; i++)
		{
		Error (PXFldType (tblHandle, i, 10, fld_type));
		if (strchr ("N$S", fld_type[0]))
			temp = 15;
		else if (fld_type[0] == 'D')
			temp = 8;
		else if (fld_type[0] == 'A')
			temp = atoi (fld_type+1);

		if (temp > longest)
			longest = temp;
		}

	return longest;
}


static WinObj wa;

void Say_Wait (int on)
{
	if (on)
		{
		if (wa.is_open ())
			return;
		wa.open (23, 0, 23, 79, W_NOBORDER, _BLUE|WHITE);
		wa.center (0, "Please Wait");
		}
	else
		wa.close ();
}
