/*                   CHOOSE ROUTINES

  copyright(c) 1990,91 by Peter F. Jones. ALL RIGHTS RESERVED.

 This software may be used and included in other programs as
   outlined in teh read.me file or your software license.

This code allows a user to select which bgi driver to try and then offers
a choice of graphics modes.

void select_driver(char *name,auto_detect_pointer_type *autodetect_pointer,
		   unsigned char *RGB_palette_allowed)
   is called first to make this selection.

int huge dummy_autodetect() is then used as the autodetect function to force the
selected driver and mode even if the autodetect functions say it wont work.
*/


#include <dir.h>
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
/*Include all autodetect function headers here*/

#include "ativw.h"
#include "ativw256.h"
#include "ativw768.h"
#include "tri256.h"
#include "tribr256.h"
#include "mcvga256.h"
#include "vesa256.h"
#include "par256.h"
#include "tsng4256.h"
#include "tsng3256.h"

#define TRUE 1
#define FALSE 0


int  select_driver_mode;

int huge dummy_autodetect()  /*used to force init to use driver, mode choosen in select_driver*/
 {
  return(select_driver_mode);
 };

 typedef struct {
			char  name[14];
			char  description[51];
			int   max_mode;
			char  mode_descriptions[6][51];
			unsigned char  RGB_palette_allowed;
                        int huge (*autodetect_function_pointer) (void);
			int  autodetect_result;
			int  autodetect_comment;
		}     bgi_drivers;

#define MAX_DRIVERS 10

static bgi_drivers driver_info[MAX_DRIVERS+1] =
				{
				{""
				},
				{
				"ATIVW256.BGI",
				"ATI VGA Wonder (256 Color Modes)",
				4,
				{
				 "320x200 256 color",
				 "640x400 256 color",
				 "640x480 256 color",
				 "800x600 256 color",
                                 "1024x768 256 color"
				},
				TRUE
				},
                                {
				"ATIVW768.BGI",
				"ATI VGA Wonder (1024x768 Color Mode)",
				0,
				{
				 "1024x768 16 color",
				 "",
				 "",
				 ""
				},
				TRUE
				},
                                {
				"TRI256.BGI",
				"TRIDENT 8800CS/8900 (256 Color Modes)",
				4,
				{
				 "320x200 256 color",
				 "640x400 256 color",
				 "640x480 256 color",
				 "800x600 256 color",
				 "1024x768 256 color"
				},
				TRUE
				},
                                {
				"TRBR256.BGI",
				"TRIDENT 8800BR (256 Color Modes)",
				4,
				{
				 "320x200 256 color",
				 "640x400 256 color",
				 "640x480 256 color",
				 "800x600 256 color",
				 "1024x768 256 color"
				},
				TRUE
				},
                                {
				"MCVGA256.BGI",
				"Standard MCGA and VGA (256 Color Modes)",
				0,
				{
				 "320x200 256 color",
				 "",
				 "",
				 "",
				 ""
				},
				TRUE
				},
                                {
				"MCVGA480.BGI",
				"MCGA and VGA 360x480 256 Color Mode",
				0,
				{
				 "360x480 256 color",
				 "",
				 "",
				 "",
				 ""
				},
				TRUE
				},
				{
				"VESA256.BGI",
				"VESA Super VGA (256 Color Modes)",
				4,
				{
				 "640x400 256 color",
				 "640x480 256 color",
				 "800x600 256 color",
				 "1024x768 256 color",
				 "1280x1024 256 color"
				},
				TRUE
				}
                                ,
				{
				"PAR256.BGI",
				"Paradise Super VGA (256 Color Modes)",
				3,
				{
				 "320x200 256 color",
				 "640x400 256 color",
				 "640x480 256 color",
				 "800x600 256 color",
				 ""
				},
				TRUE
				},
				{
				"TSNG4256.BGI",
				"TSENG 4000 Super VGA (256 Color Modes)",
				5,
				{
				"320x200 256 color",
				"640x350 256 color",
				"640x400 256 color",
				"640x480 256 color",
				"800x600 256 color",
				"1024x768 256 color"
				},
				TRUE
				},
                                {
				"TSNG3256.BGI",
				"TSENG 3000 Super VGA (256 Color Modes)",
				3,
				{
				"320x200 256 color",
				"640x350 256 color",
				"640x480 256 color",
				"800x600 256 color",
				"",
				""
				},
				TRUE
				}
				};

typedef int huge (*auto_detect_pointer_type) (void);

void select_driver(char *name, auto_detect_pointer_type *autodetect_pointer, unsigned char *RGB_palette_allowed)

{
int driver_counter,mode_counter;
int driver_to_use,mode_to_use;
struct ffblk directory_file;

#define DRIVER_NUMBER 0
#define DRIVER_NAME  5
#define	CARD_DESCRIPTION  20
#define AVAILABLE_MODES  60

#define MODE_NUMBER 0
#define MODE_NAME 5
#define MODE_COMMENT 35
#define AnyFile 0x3f

#define NO_COMMENT 0
#define COMMENT_TRY_IT 1

  driver_info[1].autodetect_function_pointer =  detect_ATI_VGA_Wonder_256;
  driver_info[1].autodetect_result = detect_ATI_VGA_Wonder_256();
  driver_info[1].autodetect_comment = NO_COMMENT;

  driver_info[2].autodetect_function_pointer = detect_ATI_VGA_Wonder_768;
  driver_info[2].autodetect_result = detect_ATI_VGA_Wonder_768();
  driver_info[2].autodetect_comment = NO_COMMENT;

  driver_info[3].autodetect_function_pointer = detect_TRIDENT_VGA;
  driver_info[3].autodetect_result = detect_TRIDENT_VGA();
  driver_info[3].autodetect_comment = NO_COMMENT;

  driver_info[4].autodetect_function_pointer = detect_TRIDENTBR_VGA;
  driver_info[4].autodetect_result = detect_TRIDENTBR_VGA();
  driver_info[4].autodetect_comment = NO_COMMENT;

  driver_info[5].autodetect_function_pointer = detect_MCGA_VGA_256;
  driver_info[5].autodetect_result = detect_MCGA_VGA_256();
  driver_info[5].autodetect_comment = NO_COMMENT;

  driver_info[6].autodetect_function_pointer = detect_MCGA_VGA_256;
  driver_info[6].autodetect_result = detect_MCGA_VGA_256();
  driver_info[6].autodetect_comment = NO_COMMENT;

  driver_info[7].autodetect_function_pointer =  detect_VESA_256;
  driver_info[7].autodetect_result = detect_VESA_256();
  driver_info[7].autodetect_comment = NO_COMMENT;

  driver_info[8].autodetect_function_pointer =  detect_PARADISE_256;
  driver_info[8].autodetect_result = detect_PARADISE_256();
  driver_info[8].autodetect_comment = NO_COMMENT;

  driver_info[9].autodetect_function_pointer =  detect_TSENG4000_256;
  driver_info[9].autodetect_result = detect_TSENG4000_256();
  if ((driver_info[9].autodetect_result)>=0)
    driver_info[9].autodetect_comment = COMMENT_TRY_IT;
   else
    driver_info[9].autodetect_comment = NO_COMMENT;

  driver_info[10].autodetect_function_pointer =  detect_TSENG3000_256;
  driver_info[10].autodetect_result = detect_TSENG3000_256();
  if ((driver_info[10].autodetect_result)>=0)
    driver_info[10].autodetect_comment = COMMENT_TRY_IT;
   else
    driver_info[10].autodetect_comment = NO_COMMENT;

printf("\n");
printf("Here are the known BGI drivers in the current directory:\n");
printf("\n");
printf("\n");
gotoxy(DRIVER_NUMBER,wherey());
printf("#");
gotoxy(DRIVER_NAME,wherey());
printf("Driver");
gotoxy(CARD_DESCRIPTION,wherey());
printf("Video Card");
gotoxy(AVAILABLE_MODES,wherey());
printf("Number of modes");
printf("\n");

  for (driver_counter=1;driver_counter<=MAX_DRIVERS;driver_counter++)
    {
      if (findfirst(driver_info[driver_counter].name,&directory_file,AnyFile)==0)
	{
	  gotoxy(DRIVER_NUMBER,wherey());
	  printf("%d)",driver_counter);
	  gotoxy(DRIVER_NAME,wherey());
	  printf("%s",driver_info[driver_counter].name);
	  gotoxy(CARD_DESCRIPTION,wherey());
	  printf("%s",driver_info[driver_counter].description);
	  gotoxy(AVAILABLE_MODES,wherey());
	  if (driver_info[driver_counter].autodetect_result>=0)
	     printf("%d",driver_info[driver_counter].autodetect_result+1);
	    else
	     printf("Wrong Video Card");

	  printf("\n");
	};
    };


  driver_to_use = -1;
  while (!((driver_to_use>=0)&&(driver_to_use<=MAX_DRIVERS)))
   {
    printf("Enter the number corresponding to the driver you wish to try :");
    scanf("%d",&driver_to_use);
    if (!((driver_to_use>=0)&&(driver_to_use<=MAX_DRIVERS))) printf("Not a valid driver number - try again ..");
   };


  printf("\n");
  printf("\n");
  printf("Here are the modes that this driver supports:");
  printf("\n");
  gotoxy(MODE_NUMBER,wherey());
  printf("#");
  gotoxy(MODE_NAME,wherey());
  printf("Mode Description");
  gotoxy(MODE_COMMENT,wherey());
  printf("Comments");
  printf("\n");

  for (mode_counter=0;mode_counter<=driver_info[driver_to_use].max_mode;mode_counter++)
      {
	  gotoxy(MODE_NUMBER,wherey());
	  printf("%d)",mode_counter);
	  gotoxy(MODE_NAME,wherey());
	  printf("%s",driver_info[driver_to_use].mode_descriptions[mode_counter]);
	  gotoxy(MODE_COMMENT,wherey());
	  if (driver_info[driver_to_use].autodetect_comment > 0)
	     {
		printf("Cant test this mode - try it - it may work");
	     }
            else
	     {
	       if (driver_info[driver_to_use].autodetect_result>=mode_counter)
		 printf("Should work on your hardware");
		else
		 printf("Will not work on your hardware");
	     };
	  printf("\n");

      };

  mode_to_use = -1;


  while (!((mode_to_use>=0)&&(mode_to_use<=driver_info[driver_to_use].max_mode)))
   {
    printf("Enter the number corresponding to the mode you wish to try :");
    scanf("%d",&mode_to_use);
    if (!((mode_to_use>=0)&&(mode_to_use<=driver_info[driver_to_use].max_mode))) printf("Not a valid mode number - try again ..\n");
   };

printf("\n");
printf("Selected driver is %s\n",driver_info[driver_to_use].name);
printf("Selected mode   is %s\n",driver_info[driver_to_use].mode_descriptions[mode_to_use]);
printf("\n");
printf("Press <Enter> or <Return> to continue ...");
getch();


 strcpy(name,"");
 strncat(name,driver_info[driver_to_use].name,(strlen(driver_info[driver_to_use].name)-4));
 select_driver_mode = mode_to_use;
 *RGB_palette_allowed = driver_info[driver_to_use].RGB_palette_allowed;
 *autodetect_pointer  = dummy_autodetect;
};



