{                   CHOOSE ROUTINES

  copyright(c) 1990,91 by Peter F. Jones. ALL RIGHTS RESERVED.

 This software may be used and included in other programs as
   outlined in teh read.me file or your software license.

This code allows a user to select which bgi driver to try and then offers
a choice of graphics modes.

select_driver(var name:string;var autodetect_pointer:pointer;
              var RGB_palette_allowed: boolean); is called first to make this
              selection.

dummy_autodetect:integer; is then used as the autodetect function to force the
selected driver and mode even if the autodetect functions say it wont work.
}


{Include all autodetect functions here}
{$I ativw256.pas}
{$I ativw768.pas}
{$I tri256.pas}
{$I mcvga256.pas}
{$I vesa256.pas}
{$I par256.pas}
{$I tsng4256.pas}
{$I tsng3256.pas}
{$I tribr256.pas}

{$F+}

var select_driver_mode : integer;
function dummy_autodetect:integer;  {used to force init to use driver, mode choosen in select_driver}
begin
   dummy_autodetect := select_driver_mode;
end;

procedure select_driver(var name:string;var autodetect_pointer:pointer;var RGB_palette_allowed: boolean);


const MAX_DRIVERS =10;



type autodetect_function_type = function:integer;
     autodetect_function_pointer_type = ^autodetect_function_type;

     bgi_drivers = record
                         name: string[13];
                         description:string[50];
                         max_mode: integer;
                         mode_descriptions: array[0..5] of string[50];
                         RGB_palette_allowed: boolean;
                         autodetect_function_pointer:  autodetect_function_pointer_type;
                         autodetect_result : integer;
                         autodetect_comment: integer;
                   end;

const NO_COMMENT = 0;
      COMMENT_TRY_IT  = 1;


const driver_info : array[1..MAX_DRIVERS] of bgi_drivers =  {holds info about each driver}
  (

   (
   name:'ATIVW256.BGI';
   description:'ATI VGA Wonder (256 Color Modes)';
   max_mode:4;
   mode_descriptions:(
                     ('320x200 256 color'),
                     ('640x400 256 color'),
                     ('640x480 256 color'),
                     ('800x600 256 color'),
                     ('1024x768 256 color'),
                     (''));
   RGB_palette_allowed: TRUE
      )
  ,
   (
   name:'ATIVW768.BGI';
   description:'ATI VGA Wonder (1024x768 Color Mode)';
   max_mode:0;
   mode_descriptions:(
                     ('1024x768 16 color'),
                     (''),
                     (''),
                     (''),
                     (''),
                     (''));
   RGB_palette_allowed: TRUE
   ),
   (
   name:'TRI256.BGI';
   description:'TRIDENT 8800CS/8900 (256 Color Modes)';
   max_mode:4;
   mode_descriptions:(
                     ('320x200 256 color'),
                     ('640x400 256 color'),
                     ('640x480 256 color'),
                     ('800x600 256 color'),
                     ('1024x768 256 color'),
                     (''));
   RGB_palette_allowed: TRUE
      ),
   (
   name:'TRIBR256.BGI';
   description:'TRIDENT 8800BR (256 Color Modes)';
   max_mode:4;
   mode_descriptions:(
                     ('320x200 256 color'),
                     ('640x400 256 color'),
                     ('640x480 256 color'),
                     ('800x600 256 color'),
                     ('1024x768 256 color'),
                     (''));
   RGB_palette_allowed: TRUE
      ),
   (
   name:'MCVGA256.BGI';
   description:'Standard MCGA and VGA (256 Color Modes)';
   max_mode:0;
   mode_descriptions:(
                     ('320x200 256 color'),
                     (''),
                     (''),
                     (''),
                     (''),
                     (''));
   RGB_palette_allowed: TRUE
      ),
   (
   name:'MCVGA480.BGI';
   description:'MCGA and VGA 360x480 256 Color Mode';
   max_mode:0;
   mode_descriptions:(
                     ('360x480 256 color'),
                     (''),
                     (''),
                     (''),
                     (''),
                     (''));
   RGB_palette_allowed: TRUE
      ),
   (
   name:'VESA256.BGI';
   description:'VESA Super VGA (256 Color Modes)';
   max_mode:4;
   mode_descriptions:(
                     ('640x400 256 color'),
                     ('640x480 256 color'),
                     ('800x600 256 color'),
                     ('1024x768 256 color'),
                     ('1280x1024 256 color'),
                     (''));
   RGB_palette_allowed: TRUE
      ),
 (
   name:'PAR256.BGI';
   description:'Paradise Super VGA (256 Color Modes)';
   max_mode:3;
   mode_descriptions:(
                     ('320x200 256 color'),
                     ('640x400 256 color'),
                     ('640x480 256 color'),
                     ('800x600 256 color'),
                     (''),
                     (''));
   RGB_palette_allowed: TRUE
      ),
 (
   name:'TSNG4256.BGI';
   description:'TSENG 4000 Super VGA (256 Color Modes)';
   max_mode:5;
   mode_descriptions:(
                     ('320x200 256 color'),
                     ('640x350 256 color'),
                     ('640x400 256 color'),
                     ('640x480 256 color'),
                     ('800x600 256 color'),
                     ('1024x768 256 color')
                     );
   RGB_palette_allowed: TRUE
      )
,
 (
   name:'TSNG3256.BGI';
   description:'TSENG 3000 Super VGA (256 Color Modes)';
   max_mode:3;
   mode_descriptions:(
                     ('320x200 256 color'),
                     ('640x350 256 color'),
                     ('640x480 256 color'),
                     ('800x600 256 color'),
                     (''),
                     ('')
                     );
   RGB_palette_allowed: TRUE
      )

  );

var driver_counter,mode_counter: integer;
    driver_to_use,mode_to_use : integer;
    directory_file: SearchRec;

const DRIVER_NUMBER =0;
      DRIVER_NAME = 5;
      CARD_DESCRIPTION = 20;
      AVAILABLE_MODES = 60;

      MODE_NUMBER =0;
      MODE_NAME = 5;
      MODE_COMMENT = 35;

begin
  driver_info[1].autodetect_function_pointer := @detect_ATI_VGA_Wonder_256;
  driver_info[1].autodetect_result := detect_ATI_VGA_Wonder_256;
  driver_info[1].autodetect_comment := NO_COMMENT;

  driver_info[2].autodetect_function_pointer := @detect_ATI_VGA_Wonder_768;
  driver_info[2].autodetect_result := detect_ATI_VGA_Wonder_768;
  driver_info[2].autodetect_comment := NO_COMMENT;

  driver_info[3].autodetect_function_pointer := @detect_TRIDENT_VGA;
  driver_info[3].autodetect_result := detect_TRIDENT_VGA;
  driver_info[3].autodetect_comment := NO_COMMENT;

  driver_info[4].autodetect_function_pointer := @detect_TRIDENTBR_VGA;
  driver_info[4].autodetect_result := detect_TRIDENTBR_VGA;
  driver_info[4].autodetect_comment := NO_COMMENT;

  driver_info[5].autodetect_function_pointer := @detect_MCGA_VGA_256;
  driver_info[5].autodetect_result := detect_MCGA_VGA_256;
  driver_info[5].autodetect_comment := NO_COMMENT;

  driver_info[6].autodetect_function_pointer := @detect_MCGA_VGA_256;
  driver_info[6].autodetect_result := detect_MCGA_VGA_256;
  driver_info[6].autodetect_comment := NO_COMMENT;


  driver_info[7].autodetect_function_pointer := @detect_VESA_256;
  driver_info[7].autodetect_result := detect_VESA_256;
  driver_info[7].autodetect_comment := NO_COMMENT;

  driver_info[8].autodetect_function_pointer := @detect_PARADISE_256;
  driver_info[8].autodetect_result := detect_PARADISE_256;
  driver_info[8].autodetect_comment := NO_COMMENT;

  driver_info[9].autodetect_function_pointer := @detect_TSENG4000_256;
  driver_info[9].autodetect_result := detect_TSENG4000_256;
  if driver_info[9].autodetect_result >= 0 then
      driver_info[9].autodetect_comment := COMMENT_TRY_IT
     else
      driver_info[9].autodetect_comment := NO_COMMENT;

  driver_info[10].autodetect_function_pointer := @detect_TSENG3000_256;
  driver_info[10].autodetect_result := detect_TSENG3000_256;
  if driver_info[10].autodetect_result >= 0 then
      driver_info[10].autodetect_comment := COMMENT_TRY_IT
     else
      driver_info[10].autodetect_comment := NO_COMMENT;


writeln('Here are the known BGI drivers in the current directory:');
writeln;
writeln;
gotoxy(DRIVER_NUMBER,wherey);
write('#');
gotoxy(DRIVER_NAME,wherey);
write('Driver');
gotoxy(CARD_DESCRIPTION,wherey);
write('Video Card');
gotoxy(AVAILABLE_MODES,wherey);
write('Number of modes');
writeln;

  for driver_counter := 1 to max_drivers do
    begin
      findfirst(driver_info[driver_counter].name,AnyFile,directory_file);
      if DosError = 0 then
        begin
          gotoxy(DRIVER_NUMBER,wherey);
          write(driver_counter,')');
          gotoxy(DRIVER_NAME,wherey);
          write(driver_info[driver_counter].name);
          gotoxy(CARD_DESCRIPTION,wherey);
          write(driver_info[driver_counter].description);
          gotoxy(AVAILABLE_MODES,wherey);
          if driver_info[driver_counter].autodetect_result>=0 then
             write(driver_info[driver_counter].autodetect_result+1)
            else
             write('Wrong Video Card');
          writeln;
        end;
    end;


  driver_to_use := -1;
  while not (driver_to_use in [0..MAX_DRIVERS]) do
   begin
    write('Enter the number corresponding to the driver you wish to try :');
    readln(driver_to_use);
    if not (driver_to_use in [0..MAX_DRIVERS]) then writeln('Not a valid driver number - try again ..');
   end;


  writeln;
  writeln;
  writeln('Here are the modes that this driver supports:');
  writeln;
  gotoxy(MODE_NUMBER,wherey);
  write('#');
  gotoxy(MODE_NAME,wherey);
  write('Mode Description');
  gotoxy(MODE_COMMENT,wherey);
  write('Comments');
  writeln;
  for mode_counter := 0 to driver_info[driver_to_use].max_mode do
      begin
          gotoxy(MODE_NUMBER,wherey);
          write(mode_counter,')');
          gotoxy(MODE_NAME,wherey);
          write(driver_info[driver_to_use].mode_descriptions[mode_counter]);
          gotoxy(MODE_COMMENT,wherey);
          if driver_info[driver_to_use].autodetect_comment > 0 then
             begin
                write('Cant test this mode - try it - it may work')
             end
            else
             begin
               if driver_info[driver_to_use].autodetect_result >= mode_counter then
                 write('Should work on your hardware')
                else
                 write('Will not work on your hardware');
             end;
          writeln;
      end;

  mode_to_use := -1;
  while not (mode_to_use in [0..driver_info[driver_to_use].max_mode]) do
   begin
    write('Enter the number corresponding to the mode you wish to try :');
    readln(mode_to_use);
    if not (mode_to_use in [0..driver_info[driver_to_use].max_mode]) then writeln('Not a valid mode number - try again ..');
   end;

writeln;
writeln('Selected driver is ',driver_info[driver_to_use].name);
writeln('Selected mode   is ',driver_info[driver_to_use].mode_descriptions[mode_to_use]);
writeln;
writeln('Press <Enter> or <Return> to continue ...');
readln;
 name := copy(driver_info[driver_to_use].name,1,length(driver_info[driver_to_use].name)-4);

 select_driver_mode:= mode_to_use;
 RGB_palette_allowed := driver_info[driver_to_use].RGB_palette_allowed;
 autodetect_pointer := @dummy_autodetect;
end;



{$F-}