MASM51
.XALL

MaxDriversNo    = 16;  <----- If you want to define more drivers change this number

; ----------------------------------------------------------------------
; Adding, deleting or changing the order of drivers definitions requires
; appriopriate changes in PRTGRAPH.H and PDrivers.pas.
; ----------------------------------------------------------------------

include drivers.inc

 MODEL FarStack large
;;.MODEL FarStack large pascal
ifNdef WithCode
   WithCode EQU 1
endif
IF WithCode

   .CODE

   EXTRN  Pascal PRT__DriversPtr: word:2
   PUBLIC pascal PRT_LinkDriversDefinitions
   PRT_LinkDriversDefinitions PROC pascal FAR
                   mov  AX, seg PRT__DriversPtr
                   mov  ES,AX
                   mov  ES:PRT__DriversPtr, offset PRT__Drivers
                   mov  ES:PRT__DriversPtr+2, seg PRT__Drivers
                   RET
   PRT_LinkDriversDefinitions ENDP

ENDIF

  .DATA

               even
PRT__Drivers   LABEL WORD
PRT__MaxDriverNo dw  ?  ; will be defined at the end of the file
                 dw  2  ; index to PRT__DriversOffsets
PRT__DriversOffsets  dw  MaxDriversNo dup (0) ; place for drivers definitions offsets


        ; /*===============================*/
        ; /* 9-pins : STAR SR              */
        ; /*===============================*/
         DriverDef
         ;         4,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
         DriverName      <'9 pins: STAR SR'> ;
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      NULL;                   /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
         CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <1bh,'M'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      <1bh,'R'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv */
         ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  60,72,2;                       /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette   NULL;                    /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'g',0>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,2,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,72,2;                      /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette   NULL;                    /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'g',1>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,2,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,144,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'g',1>,NULL
         PinsPerHead    8
         PixelsStep     2
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  240,144,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette     NULL;                  /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'g',3>,NULL
         PinsPerHead    8
         PixelsStep     2
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         EndDriverDef   ; <----------------------------


         ;/*===============================*/
         ;/* 9 pins : IBM, EPSON */
         ;/* graphic mode: Esc, 'K'/'L'/'Z'  */
         ;/*===============================*/

         DriverDef
         ;         4,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
         DriverName     <'9 pins: IBM, EPSON'>
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      NULL;                   /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
         CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      <_Esc,'c'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv */
         ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  60,72,2;                       /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'K'>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,72,2;                      /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'L'>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,216,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'L'>,NULL
         PinsPerHead    8
         PixelsStep     3
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  240,216,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'Z'>,NULL
         PinsPerHead    8
         PixelsStep     3
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         EndDriverDef   ; <----------------------------


         ;/*===============================*/
         ;/* 9 pins : EPSON  II            */
         ;/* graphic mode: Esc '*' n       */
         ;/*===============================*/

         DriverDef
         ;         4,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
         DriverName     <'9 pins: Epson II'>
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      NULL;                   /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
         CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      <_Esc,'c'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv */
         ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  60,72,2;                       /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',0>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,72,2;                      /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',1>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,216,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',1>,NULL
         PinsPerHead    8
         PixelsStep     3
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  240,216,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',3>,NULL
         PinsPerHead    8
         PixelsStep     3
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         EndDriverDef   ; <----------------------------

         ;/*===============================*/
         ;/* 9-pins : PANASONIC KX-P1124   */
         ;/*===============================*/

         DriverDef
         ;         4,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
         DriverName       <'9 pins: Panasonic KX-P1124'>
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      NULL;                   /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
         CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      <_Esc,'c'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv */
         ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  60,72,2;                       /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'K'>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,5,2          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,72,2;                      /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'L'>,NULL
         PinsPerHead    8
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,5,2;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,144,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette   NULL;                    /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'L'>,NULL
         PinsPerHead    8
         PixelsStep     2
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,5,4;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  240,144,2;                     /* X and Y densities,, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'Z'>,NULL
         PinsPerHead    8
         PixelsStep     2
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,5,4;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
         EndDriverDef   ; <----------------------------

         if 0
            ;/*===============================*/
            ;/* 9 pins : IBM, EPSON color */
            ;/*===============================*/

            DriverDef
            ;         4,                            /* ModesNo  */
            CompressionType  0                      /* CompressionType */
            DriverName       <'9 pins(color): IBM, EPSON'>
            ASCIInumbers    0;
            TransferValueInBytes 0;                 /*  TransferValueInBytes  */
            InitPRTStr      <_Esc,'U1'>;             /* Init PRT string */
            EndPRTStr       NULL;                   /* End PRT string */
            CompressedStr   NULL;                   /* CompressedStr  */
            UncompressedStr NULL;                   /* UncompressedStr  */
            LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
            TopMargin      <_Esc,'c'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv */
            ColorsStrings  <_Esc,'r'>,NULL, NULL;    /* ColorStr1,ColorStr2, ColorsMap */

            ModeDef  60,72,8;                       /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette   NULL;                    /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'K'>,NULL
            PinsPerHead    8
            PixelsStep     1
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  120,72,8;                      /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */ /* ?????????????????????????????? */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'L'>,NULL
            PinsPerHead    8
            PixelsStep     1
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  120,216,8;                     /* X and Y densities */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'L'>,NULL
            PinsPerHead    8
            PixelsStep     3
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  240,216,8;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'Z'>,NULL
            PinsPerHead    8
            PixelsStep     3
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
            EndDriverDef   ; <----------------------------

         else

            ;/*===============================*/
            ;/* 9 pins : IBM, EPSON color */
            ;/*===============================*/
            ;/* the same as previous but with Planes and SimPlanes bits on */
            ;/* This introduces some optimalization in changing ribbon  */
            ;/* current color but it assumes that any composed color */
            ;/* can be build from colors c1 and c2 which are  */
            ;/* power of 2. E.G. color orange(0x5) is composed */
            ;/* of yellow(4) and red(1).                      */
            ;/* It may not work for more than 7 colors available. */
            DriverDef
            ;         4,                            /* ModesNo  */
            CompressionType  0                      /* CompressionType */
            DriverName       <'9 pins(color): IBM, EPSON'>
            ASCIInumbers    0;
            TransferValueInBytes 0;                 /*  TransferValueInBytes  */
            InitPRTStr      <_Esc,'U1'>;             /* Init PRT string */
            EndPRTStr       NULL;                   /* End PRT string */
            CompressedStr   NULL;                   /* CompressedStr  */
            UncompressedStr NULL;                   /* UncompressedStr  */
            LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
            TopMargin      <_Esc,'c'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv */
            ColorsStrings  <_Esc,'r'>,NULL, NULL;    /* ColorStr1,ColorStr2, ColorsMap */

            ModeDef  60,72,8;                       /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'K'>,NULL
            PinsPerHead    8
            PixelsStep     1
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  120,72,8;                      /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */ /* ?????????????????????????????? */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'L'>,NULL
            PinsPerHead    8
            PixelsStep     1
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  120,216,8;                     /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'L'>,NULL
            PinsPerHead    8
            PixelsStep     3
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  240,216,8;                     /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'Z'>,NULL
            PinsPerHead    8
            PixelsStep     3
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
            EndDriverDef   ; <----------------------------
         endif


            ;/*===============================*/
            ;/* 9 pins : Epson II color */
            ;/*===============================*/
            ;/* graphic mode: Esc '*' n */
            ;/*
            DriverDef
            ;         4,                            /* ModesNo  */
            CompressionType  0                      /* CompressionType */
            DriverName       <'9 pins(color): Epson II'>
            ASCIInumbers    0;
            TransferValueInBytes 0;                 /*  TransferValueInBytes  */
            InitPRTStr      <_Esc,'U1'>;             /* Init PRT string */
            EndPRTStr       NULL;                   /* End PRT string */
            CompressedStr   NULL;                   /* CompressedStr  */
            UncompressedStr NULL;                   /* UncompressedStr  */
            LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
            TopMargin      <_Esc,'c'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv */
            ColorsStrings  <_Esc,'r'>,NULL, NULL;    /* ColorStr1,ColorStr2, ColorsMap */

            ModeDef  60,72,8;                       /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'*',0>,NULL
            PinsPerHead    8
            PixelsStep     1
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  120,72,8;                      /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */ /* ?????????????????????????????? */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'*',1>,NULL
            PinsPerHead    8
            PixelsStep     1
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  120,216,8;                     /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
            InitTransfer <CR, _Esc,'*',1>,NULL
            PinsPerHead    8
            PixelsStep     3
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  240,216,8;                     /* X and Y densities, ColorsNo */
            ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   NULL;                    /* InitGraphStr */
            EndGraphStr    NULL;                    /* EndGraphStr  */
            PicWidth
         InitTransfer <CR, _Esc,'*',3>,NULL
            PinsPerHead    8
            PixelsStep     3
            EolnStr   NULL;                         /* EolnStr          */
            SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
            EndDriverDef   ; <----------------------------


         ;/*===============================*/
         ;/* Epson LQ 1000                 */
         ;/*===============================*/

         DriverDef
         ;         5,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
         DriverName       <'24 pins: Epson LQ1000'>
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      NULL;                   /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
       CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      <_Esc,'r'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv ??????????????? ?????????? */
         ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  60,180,2;                      /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',20h>,NULL
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,180,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
       ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',21h>,NULL
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  180,180,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',27h>,NULL
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
       SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  360,180,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',28h>,NULL
         PinsPerHead    24
         PixelsStep     1
       EolnStr   NULL;                         /* EolnStr          */
       SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

       ModeDef  360,360,2;                     /* X and Y densities, ColorsNo */
       ModeOptions  0;                         /* Planes, SimPlanes */
       ColorPalette       NULL;                /* Color palette        */
       InitGraphStr   NULL                    /* InitGraphStr */
       EndGraphStr    <_Esc,'@'>;               /* EndGraphStr  */
       PicWidth
       InitTransfer <CR, _Esc,'*',28h>,NULL
       PinsPerHead    24
       PixelsStep     2
       EolnStr   NULL;                         /* EolnStr          */
       SmallEoln  <_Esc,'+'>,NL,1,1;            /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
       EndDriverDef   ; <----------------------------

       ;/*===============================*/
       ;/*   IBM Pro X24                 */
       ;/*===============================*/
       DriverDef
       ;         5,                            /* ModesNo  */
       CompressionType  0                      /* CompressionType */
       DriverName       <'24 pins: IBM Pro X24'>
       ASCIInumbers    0;
       TransferValueInBytes 0;                 /*  TransferValueInBytes  */
       InitPRTStr      NULL;                   /* Init PRT string */
       EndPRTStr       NULL;                   /* End PRT string */
       CompressedStr   NULL;                   /* CompressedStr  */
       UncompressedStr NULL;                   /* UncompressedStr  */
       LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
       TopMargin      <_Esc,'r'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv ???????????? */
       ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

       ModeDef  60,180,2;                      /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<8>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

       ModeDef  120,180,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<9>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

       ModeDef  180,180,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<11>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

       ModeDef  360,180,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<12>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

      ModeDef  360,360,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    <_Esc,'@'>;               /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<12>,-1
         PinsPerHead    24
         PixelsStep     2
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_FS,'3'>,NL,1,1;            /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
         EndDriverDef   ; <----------------------------

         ;/*===============================*/
         ;/* EPSON LQ860                   */
         ;/*===============================*/
         DriverDef
         ;         5,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
       DriverName       <'24 pins(color): EPSON LQ860'>
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      <_Esc,'U1'>;             /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
         CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      NULL,NULL,1,1;             /* TopMarginStr1,TopMarginStr2,TopMarginDiv ???????????????? */
         ColorsStrings  <_Esc,'r'>,NULL, NULL;    /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  60,180,8;                      /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',20h>,NULL
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,180,8;                     /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',21h>,NULL
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  180,180,8;                     /* X and Y densities,, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',27h>,NULL
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  360,180,8;                     /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',28h>,NULL
         PinsPerHead    24
         PixelsStep     1
         EolnStr   NULL;                         /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,1,1;          /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  360,360,8;                     /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    <_Esc,'@'>;               /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'*',28h>,NULL
         PinsPerHead    24
         PixelsStep     2
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_Esc,'+'>,NL,1,1;            /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
         EndDriverDef   ; <----------------------------

         ;/*===============================*/
         ;/* 24 pin IBM Pro X24 (color)    */
         ;/*===============================*/
         DriverDef
         ;         5,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
         DriverName       <'24 pins(color): IBM Pro X24'>
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      <_Esc,'U1'>;             /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
         CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      NULL,NULL,1,1;             /* TopMarginStr1,TopMarginStr2,TopMarginDiv ???????????? */
         ColorsStrings  <_Esc,'r'>,NULL, NULL;    /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  60,180,8;                      /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0B4",
         EndGraphStr    NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0D8",
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<8>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,180,8;                     /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0B4",
         EndGraphStr    NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0D8",
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<9>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  180,180,8;                     /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0B4",
         EndGraphStr    NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0D8",
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<11>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  360,180,8;                     /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0B4",
         EndGraphStr    NULL;          ;// "\x01b[\\""\x04" "\x00""\x00""\x00""\x00""\x0D8",
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<12>,-1
         PinsPerHead    24
         PixelsStep     1
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_Esc,'J'>,NULL,29,24;        /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  360,360,8;                     /* X and Y densities, ColorsNo */
         ModeOptions  SimPlanes;                 /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    <_Esc,'@'>;               /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,'[g'>,<12>,-1
         PinsPerHead    24
         PixelsStep     2
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_FS,'3'>,NL,1,1;            /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
         EndDriverDef   ; <----------------------------

            ;/* PaintJet */
            ;/*    without Run Length Encoding compression     */
            ;/*===============================*/
            ;/* general PaintJet       */
            ;/*===============================*/
            DriverDef
            ;         3,                            /* ModesNo  */
            CompressionType  0                      /* CompressionType */
            DriverName       <'PaintJet'>
            ASCIInumbers    1;
            TransferValueInBytes 1;                 /*  TransferValueInBytes  */
            InitPRTStr      <_Esc,'9', _Esc,'&s1C',_Esc,'*b0M'>;  /* Init PRT string */
            EndPRTStr       <_Esc,'*r0B'>;                   /* End PRT string */
            CompressedStr   NULL;                   /* CompressedStr  */
            UncompressedStr NULL;                   /* UncompressedStr  */
            LeftMargin     <_Esc,'&a'>,<'H'>,1,1;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
            TopMargin      <_Esc,'&l'>,<'E'>,1,166;    /* TopMarginStr1,TopMarginStr2,TopMarginDiv ???????????? */
            ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

            ModeDef  90,90,2;                       /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t90R', _Esc,'*r1U', _Esc,'*r1A' >;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  180,180,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t180R', _Esc,'*r1U', _Esc,'*r1A'>;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  90,90,16;                      /* X and Y densities, ColorsNo */
            ModeOptions  Planes;                    /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t90R', _Esc,'*r4U', _Esc,'*r1A' >;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'V'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        <_Esc,'*b0W'>;            /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  180,180,8;                     /* X and Y densities, ColorsNo */
            ModeOptions  Planes;                    /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t180R', _Esc,'*r3U', _Esc,'*r1A'>;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'V'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        <_Esc,'*b0W'>;            /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
            EndDriverDef   ; <----------------------------


            ;/*===============================*/
            ;/* Hewlet Packard PaintJet       */
            ;/*===============================*/
            DriverDef
            ;         4,                            /* ModesNo  */
            CompressionType  PRT__RLE_COMPRESSION   /* CompressionType */
            DriverName       <'HP PaintJet'>
            ASCIInumbers    1;
            TransferValueInBytes 1;                 /*  TransferValueInBytes  */
            InitPRTStr      <_Esc,'9', _Esc,'&s1C'>;  /* Init PRT string */
            EndPRTStr       <_Esc,'*r0B'>;           /* End PRT string */
            CompressedStr   <_Esc,'*b1M'>;           /* CompressedStr  */
            UncompressedStr <_Esc,'*b0M'>;           /* UncompressedStr  */
            LeftMargin     <_Esc,'&a'>,<'H'>,1,1;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
            TopMargin      <_Esc,'&l'>,<'E'>,1,166;    /* TopMarginStr1,TopMarginStr2,TopMarginDiv ???????????? */
            ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

            ModeDef  90,90,2;                       /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t90R', _Esc,'*r1U', _Esc,'*r1A'>;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  180,180,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t180R', _Esc,'*r1U', _Esc,'*r1A'>;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  90,90,16;                      /* X and Y densities, ColorsNo */
            ModeOptions  Planes;                    /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t90R', _Esc,'*r4U', _Esc,'*r1A'>;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'V'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        <_Esc,'*b0W'>;            /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  180,180,8;                     /* X and Y densities, ColorsNo */
            ModeOptions  Planes;                    /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t180R', _Esc,'*r3U', _Esc,'*r1A'>;
            EndGraphStr    NULL;
            PicWidth       <_Esc,'*r'>,<'S'>,1,1
            InitTransfer <_Esc,'*b'>,<'V'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        <_Esc,'*b0W'>;            /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
            EndDriverDef   ; <----------------------------

            ;/* LaserJet */
            ;/*    without Run Length Encoding compression     */
            ;/*===============================*/
            ;/* general LaserJet       */
            ;/*===============================*/
            DriverDef
            ;         4,                            /* ModesNo  */
            CompressionType  0                      /* CompressionType */
            DriverName       <'LaserJet'>
            ASCIInumbers    1;
            TransferValueInBytes 1;                 /*  TransferValueInBytes  */
            InitPRTStr      <_Esc,'9', _Esc,'&s1C', _Esc,'*b0M'>;  /* Init PRT string */
            EndPRTStr       NULL;                   /* End PRT string */
            CompressedStr   NULL;                   /* CompressedStr  */
            UncompressedStr NULL;                   /* UncompressedStr  */
            LeftMargin     <_Esc,'*p'>,<'X'>,3,10;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
            TopMargin      <_Esc,'&l'>,<'E'>,1,166;    /* TopMarginStr1,TopMarginStr2,TopMarginDiv ????? */
            ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

            ModeDef  75,75,2;                       /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t75R', _Esc,'*r1A' >;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  100,100,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t100R', _Esc,'*r1A' >;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  150,150,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t150R', _Esc,'*r1A'>;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  300,300,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t300R', _Esc,'*r1A'>;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
            EndDriverDef   ; <----------------------------


            ;/*===============================*/
            ;/* Hewlet Packard LaserJet       */
            ;/*===============================*/
            DriverDef
            ;         4,                            /* ModesNo  */
            CompressionType  PRT__RLE_COMPRESSION   /* CompressionType */
            DriverName       <'HP LaserJet'>
            ASCIInumbers    1;
            TransferValueInBytes 1;                 /*  TransferValueInBytes  */
            InitPRTStr      <_Esc,'9', _Esc,'&s1C'>;  /* Init PRT string */
            EndPRTStr       NULL;                   /* End PRT string */
            CompressedStr   <_Esc,'*b1M'>;           /* CompressedStr  */
            UncompressedStr <_Esc,'*b0M'>;           /* UncompressedStr  */
            LeftMargin     <_Esc,'*p'>,<'X'>,3,10;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
            TopMargin      <_Esc,'&l'>,<'E'>,1,166;    /* TopMarginStr1,TopMarginStr2,TopMarginDiv ???????????? */
            ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

            ModeDef  75,75,2;                       /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t75R', _Esc,'*r1A'>;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  100,100,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t100R', _Esc,'*r1A'>;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  150,150,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t150R', _Esc,'*r1A'>;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

            ModeDef  300,300,2;                     /* X and Y densities, ColorsNo */
            ModeOptions  0;                         /* Planes, SimPlanes */
            ColorPalette       NULL;                /* Color palette        */
            InitGraphStr   <_Esc,'*t300R', _Esc,'*r1A'>;
            EndGraphStr    <_Esc,'*rB'>;
            PicWidth
            InitTransfer <_Esc,'*b'>,<'W'>
            PinsPerHead    1
            PixelsStep     1
            EolnStr        NULL;                    /* EolnStr          */
            SmallEoln      NULL,NULL,1,1;           /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
            EndDriverDef   ; <----------------------------


   if   0
         ;/*===============================*/
         ;/* 9 pins : EPSON                */
         ;/*===============================*/
         DriverDef
         ;         2,                            /* ModesNo  */
         CompressionType  0                      /* CompressionType */
         DriverName       <'9 pin: EPSON (9 pin graphic)'>
         ASCIInumbers    0;
         TransferValueInBytes 0;                 /*  TransferValueInBytes  */
         InitPRTStr      NULL;                   /* Init PRT string */
         EndPRTStr       NULL;                   /* End PRT string */
         CompressedStr   NULL;                   /* CompressedStr  */
         UncompressedStr NULL;                   /* UncompressedStr  */
         LeftMargin     <_Esc,'l'>,NULL,1,100;      /* LeftMarginStr1,LeftMarginStr2,LeftMarginDiv */
         TopMargin      <_Esc,'c'>,NULL,1,166;      /* TopMarginStr1,TopMarginStr2,TopMarginDiv ???????????? */
         ColorsStrings  NULL,NULL, NULL;         /* ColorStr1,ColorStr2, ColorsMap */

         ModeDef  120,72;                        /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,05Eh,1>,NULL
         PinsPerHead    9
         PixelsStep     1
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,3,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */

         ModeDef  120,216,2;                     /* X and Y densities, ColorsNo */
         ModeOptions  0;                         /* Planes, SimPlanes */
         ColorPalette       NULL;                /* Color palette        */
         InitGraphStr   NULL;                    /* InitGraphStr */
         EndGraphStr    NULL;                    /* EndGraphStr  */
         PicWidth
         InitTransfer <CR, _Esc,05Eh,1>,NULL
         PinsPerHead    9
         PixelsStep     3
         EolnStr        NULL;                    /* EolnStr          */
         SmallEoln  <_Esc,04Ah>,NULL,1,1;         /* SmallEoln,SmallEolnMult,SmallEolnDiv   */
         EndDriverDef   ; <----------------------------
   endif


org PRT__MaxDriverNo
    dw   DriversNo

    if   DriversNo GT MaxDriversNo
         err Too many drivers definitions, change MaxDriversNo at the file beginning
         DriversNo = MaxDriversNo;
    endif
    d = 0
    org PRT__DriversOffsets
    Rept DriversNo
         d = d+1
         genstmnt  <D_offs>,,<=>,,<DriverDefOffs_>,%d
         dw        D_offs ; driver definition offset
    ENDM

     END

     END
