
/*
;---------------------------------------------------------------------------
;
; File......... MakDoc.h
;
; Description.. include file for MakDoc.c --> MakDoc.EXE
;
; Author....... Preston Stroud
;
; Date......... December 1991
;
; Company...... The West Company
;               3910 Rouse Rd
;               P.O. Box 1048
;               Kinston, NC 28501
;
;---------------------------------------------------------------------------
*/


/*--- Constants ----------------------------------------------------------*/

#define DEBUG                          0

#define MAXHELPNAME                    45
#define MAXDATALINE                    133
#ifndef TRUE
   #define TRUE                        1
   #define FALSE                       0
#endif
#ifndef YES
   #define YES                         1
   #define NO                          0
#endif

#define CurrentPage()                  PstPpnm

#define HELPBREAK                      0
#define PAGEBREAK                      1

/*--- Record Structures --------------------------------------------------*/

TYP struct indextype
{
   IntT page;
   ChrT helpname[MAXHELPNAME+1];
   IntT helpnbr;
   struct indextype *next;
} INDEXTYPE;


TYP struct datatype
{
   FILE *fn;                           /* pointer to input file           */
   FILE *hfn;                          /* pointer to header file          */
   INDEXTYPE *firstindex;              /* pointer to linked list for index*/
   ChrT HeaderFileName[81];            /* header file name                */
   ChrT OutFileName[81];               /* output file name                */
   ChrT headtext[81];                  /* header text line                */
   IntT start;                         /* processing body of help screen  */
   IntT end;                           /* processed end of help screen    */
   IntT head;                          /* processing header of input file */
   ChrT buff[MAXDATALINE+1];           /* data line read from input file  */
   IntT currhelpnbr;                   /* current help number being proc. */
   ChrT currhelpname[MAXHELPNAME+1];   /* current help name               */
   IntT currpage;                      /* current page number             */
} DATATYPE;


/*--- Globals ------------------------------------------------------------*/

#ifdef MAINMODULE

LCL DATATYPE data;

#else

GBL LCL DATATYPE data;

#endif


/*--- function prototypes ------------------------------------------------*/

LCL VOID  CTYP  Initialize(ChrP argv[], IntT argc);
LCL VOID  CTYP  MainProcess(NOARG);
LCL VOID  CTYP  ProcessData(NOARG);
LCL VOID  CTYP  ProcessSummary(NOARG);
LCL VOID  CTYP  ProcessRef(NOARG);
LCL VOID  CTYP  ErrorExit(ChrP msg);
LCL VOID  CTYP  NormalExit(NOARG);
LCL VOID  CTYP  PrBreaker(IntT breaktype );
LCL VOID  CTYP  ProcessStart(NOARG);
LCL VOID  CTYP  SortIndex(NOARG);
LCL VOID  CTYP  InfoExit(NOARG);

