// Copyright 1991 (c),   Lake View Software
//                       4321 Harborough Rd.
//                       Columbus, OH 43220
// LVS Windows Library
// newtbl.cpp

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "lvswin.hpp"
#include "lvsmenu.hpp"
#include "pxengine.h"
#include "br.hpp"

static int Fields;
static int Keys;
static char Table [9] = "";

static int Get_Name ();
static void Edit_Struct (int use_current);

void New_Table ()
{
	int 
        exists,
        use_current = 0;

	if (tblHandle)
		use_current =
			Win_Get_YN ("Start with the current tables structure (y/n)");

	if (use_current)
        {
		Fields = flds;
        Keys = keys;
        }
    else
        {
        Fields = 5;
        Keys = 1;
        }
	if (!Get_Name ())
        return;

    if (Error (PXTblExist (Table, &exists)))
        return;

    if (exists)
        {
        Win_Error ("Table Exists!");
        return;
        }

    Edit_Struct (use_current);
}

static int Build_Struct (int use_current, char **name, char **type)
{
    for (int i=0; i<Fields; i++)
        {
        if (!name[i] || !type[i])
            return 0;

        if (use_current && (i < flds))
            {
    		if (Error (PXFldName (tblHandle, i+1, 26, name[i])))
                return 0;
            if (Error (PXFldType (tblHandle, i+1, 6, type[i])))
                return 0;
            }
        else
            {
            name[i][0] = '\0';
            type[i][0] = '\0';
            }
        }
    return 1;
}

static void Edit_Struct (int use_current)
{
    char **name,
         **type;
    FIELDHANDLE keys[255];
    int height;
    WinObj s;

    name = (char **) malloc (sizeof(char *) * 255);
    type = (char **) malloc (sizeof(char *) * 255);
    for (int i=0; i<255; i++)
        {
        if (i<Fields)
            {
            name[i] = new char [26];
            type[i] = new char [6];
            }
        else
            {
            name[i] = 0;
            type[i] = 0;
            }
        }


    if (!Build_Struct (use_current, name, type))
        goto cleanup;

    do  {
        Say_Wait (0);

	    s.set_virtual (Fields+1, 0);
        height = Fields;
	    if (height > 18)
		    height = 18;
	    s.open (2, 39, 4 + height, 78, W_DOUSIN, _CYAN|RED, _CYAN|BLUE);
        s.shadow ();
	    s.title (" Build Structure ");
	    s.printf (0, 6, "Field");
	    s.printf (0, 32, "Type");
        s.set_attr (_CYAN|BLACK);

        for (i=0; i<Fields; i++)
            {
            s.printf (i+1, 0, "%3d.", i+1);
            s.get (i+1,  6, name[i], 'U', 25);
            s.get (i+1, 32, type[i], 'U', 5);
            }

        if (s.read () == ESC)
            goto cleanup;

        if (!Win_Get_YN ("Create your new table (y/n)"))
            goto cleanup;

        /*
        * Trim all the names and types
        */
        strtrim (Table);
        for (i=0; i<Fields; i++)
            {
            strtrim (name[i]);
            strtrim (type[i]);
            }

        Say_Wait (1);
        }
    while (Error (PXTblCreate (Table, Fields, name, type)));

    if (Keys)
        {
        for (i=0; i<Keys; i++)
            keys[i] = i+1;

        if (Error (PXKeyAdd (Table, Keys, keys, PRIMARY)))
            goto cleanup;
        }

cleanup:;
    for (i=0; i<Fields; i++)
        {
        if (name[i])
            delete name[i];
        if (type[i])
            delete type[i];
        }
    free (name);
    free (type);
}

static int Get_Name ()
{
    WinObj w;
    w.open (4, 20, 12, 60, W_DOUSIN, _GREEN|WHITE, _GREEN|BLACK);
    w.shadow ();
    w.title (" New Table ");

    w.puts (1, 1, " Table Name:");
    w.puts (3, 1, "# of Fields:");
    w.puts (5, 1, "  # of Keys:");

    w.get (1, 14, Table, 'U', 8);
    w.get (3, 14, Fields, 3);
    w.get (5, 14, Keys, 2);

    if (w.read () == ESC)
        return 0;
    
    cut_spaces (Table);
    strtrim (Table);
    if (!Table [0])
        {
        Win_Error ("Table must have a name!");
        return 0;
        }
    if (Fields > 255 || Fields < 1)
        {
        Win_Error ("Fields must be between 1 and 255!");
        return 0;
        }
    if (Keys > Fields)
        {
        Win_Error ("Keys can not exceed Fields!");
        return 0;
        }

    return 1;
}
