

{$F+}

function detect_PARADISE_256 : integer;
{
This a standard autodetect function as outlines in the Turbo Pascal Manual.
If the card is detected, the highest available mode number is returned.
Otherwise a negative number indicating an error is returned.


copyright(c) 1990 by Peter F. Jones. ALL RIGHTS RESERVED.
This software may be used and included in other programs as
outlined in your software license.
}
const copyrighttrident: string[60] = 'copyright(c) 1990 by Peter F. Jones. ALL RIGHTS RESERVED.';

function paradise_test_memory:integer;
{returns number of 64k segements}
  var number_of_segments :integer;
      regs : registers;
begin
      regs.ax := $007f;    {extended functions  }
      regs.bh  := $02;     {mode query}
      intr($10,regs);
      number_of_segments := regs.ch and $00FF;
      paradise_test_memory := number_of_segments;
end;
const manufacturer: string = 'WESTERN';   {WESTERN DIGITAL}

var found,done : boolean;
    counter,found_counter : integer;
begin
  detect_PARADISE_256 := -11;   {return error if not found}
  found := false;

  done := false;
  counter := 0;
  found_counter := 1;
  while not done do
     begin
       if chr(mem[$c000:counter]) = manufacturer[found_counter] then
            begin
              found := found_counter = length(manufacturer);
              done := found;
              found_counter := found_counter + 1;
            end
           else
            begin
              found_counter := 1;
            end;
        counter := counter + 1;
        if counter > 200 then done := true;
      end;
  if not found then exit;

    port[$3ce] := $9;          {select bank register }
    found := port[$3cf]=0;


  if not found then exit;


  if (paradise_test_memory>=5) then  {if 320k}
          begin
             detect_PARADISE_256 := 2; {check 640x480}
             exit;
          end;

  if (paradise_test_memory>=8) then  {if 512k}
          begin
             detect_PARADISE_256 := 3; {check 800x600}
             exit;
          end;


  detect_PARADISE_256 := 1; {640x400 as default}
  exit;


     end;
{$F-}


