

{$F+}

function detect_TRIDENT_VGA : integer;
{
This a standard autodetect function as outlines in the Turbo Pascal Manual.
If the card is detected, the highest available mode number is returned.
Otherwise a negative number indicating an error is returned.


copyright(c) 1990 by Peter F. Jones. ALL RIGHTS RESERVED.
This software may be used and included in other programs as
outlined in your software license.
}
const copyrighttrident: string[60] = 'copyright(c) 1990 by Peter F. Jones. ALL RIGHTS RESERVED.';

function trident_test_memory:integer;
{trident_memory  0=256k,1=512k,2=768k,3=1024k}

begin
   port[$3d4] := $1f;  {page 79 of 8900 manual }
   trident_test_memory := port[$3d5] and 3;
end;


var found : boolean;
    version: integer;

begin
  detect_TRIDENT_VGA := -11;   {return error if not found}
  found := false;
  port[$3c4] := $b;  {page 1 of TVGA8900 Quick Ref}

  version := port[$3c5];
  if version > 15 then version := 0;

{  writeln('version ',version);
   writeln('memory ',trident_test_memory);
}

  found :=  version >1;

  if not found then exit;

  if (trident_test_memory>=2)and(version>=3) then  {if 768k and version 3}
          begin
             detect_TRIDENT_VGA := 4; {check 1024x768}
             exit;
          end;

  if (trident_test_memory>=1)and(version>=3) then  {if 512k and version 3}
          begin
             detect_TRIDENT_VGA := 3; {check 800x600}
             exit;
          end;

  if (trident_test_memory>=1)and(version>=2) then  {if 512k and version 2}
          begin
             detect_TRIDENT_VGA := 2; {check 640x480}
             exit;
          end;

  detect_TRIDENT_VGA := 1; {640x400 as default}
  exit;


     end;
{$F-}


