#include <graphics.h>
#include "tsng4256.h"
/*
This a standard autodetect function as outlines in the Turbo Pascal Manual.
If the card is detected, a mode number is returned.
There does not seem to be a consistent way of determining which modes are
valid so we have choosen the 640x480 mode as a default. See the last few lines
of this routine to change the default mode.

If the card is  not found a negative number indicating an error is returned.


copyright(c) 1991 by Peter F. Jones. ALL RIGHTS RESERVED.
This software may be used and included in other programs as
outlined in your software license.
*/

char   copyrighttseng3000[] = "copyright(c) 1991 by Peter F. Jones. ALL RIGHTS RESERVED.";

int huge detect_TSENG3000_256()
    {

     int graphdriver,graphmode,return_value;
     unsigned char found,old_bank,dummy_bank;

	return_value = -11;
	graphdriver=0;
	detectgraph(&graphdriver,&graphmode);

	found = (graphdriver==9);  /* 9 = VGA */
      if (found)  found = (detect_TSENG4000_256()==-11);   /* if TSENG4000 found then not 3000 */

   if (found)
      {
       old_bank = inportb(0x3cd);
       outportb(0x3cd,0x6a);
       dummy_bank = inportb(0x3cd);
       found =  dummy_bank == 0x6a;
       outportb(0x3cd,old_bank);

      };


if (found)
      {
       old_bank = inportb(0x3cd);
       outportb(0x3cd,0x55);
       dummy_bank = inportb(0x3cd);
       found =  dummy_bank == 0x55;
       outportb(0x3cd,old_bank);
      }

  if (!found) return(return_value);

  /*************************************************************************/
  /*************************************************************************/
  /*************************************************************************/
  /*************************************************************************/
  /*Change the mode number on the next line to whatever you need as a default*/

  return_value = 2; /*640x480 as default*/

  /*************************************************************************/
  /*************************************************************************/
  /*************************************************************************/

   return(return_value);

   }

