#include <graphics.h>

/*
This a standard autodetect function as outlines in the Turbo Pascal Manual.
If the card is detected, a mode number is returned.
There does not seem to be a consistent way of determining which modes are
valid so we have choosen the 640x480 mode as a default. See the last few lines
of this routine to change the default mode.

If the card is  not found a negative number indicating an error is returned.


copyright(c) 1991 by Peter F. Jones. ALL RIGHTS RESERVED.
This software may be used and included in other programs as
outlined in your software license.
*/

char   copyrighttseng4000[] = "copyright(c) 1991 by Peter F. Jones. ALL RIGHTS RESERVED.";

int huge detect_TSENG4000_256()
    {

     int graphdriver,graphmode,return_value;
     unsigned char found,old_extended_start_address,dummy_extended_start_address;

	return_value = -11;
	graphdriver=0;
	detectgraph(&graphdriver,&graphmode);

	found = (graphdriver==9);  /* 9 = VGA */


   if (found)
      {
       outportb(0x3d4,0x33);  /*CRTC Extended Start Address index P130 of TSENG4000 manual*/
       old_extended_start_address = inportb(0x3d5);
       outportb(0x3d5,0x0a);  /*set it to 0a*/
       dummy_extended_start_address = inportb(0x3d5);
       dummy_extended_start_address =   dummy_extended_start_address & 0x0f;
       found =  (dummy_extended_start_address == 0x0a);
      };


if (found)
      {
       outportb(0x3d5,0x05);  /*set it to 05*/
       dummy_extended_start_address = inportb(0x3d5);
       dummy_extended_start_address =   dummy_extended_start_address & 0x0f;
       found =  (dummy_extended_start_address == 0x05);
      };

 if (found)
      {
       outportb(0x3d5,old_extended_start_address);
      };

  if (!found) return(return_value);

  /*************************************************************************/
  /*************************************************************************/
  /*************************************************************************/
  /*************************************************************************/
  /*Change the mode number on the next line to whatever you need as a default*/

  return_value = 3; /*640x480 as default*/

  /*************************************************************************/
  /*************************************************************************/
  /*************************************************************************/

   return(return_value);

   }

