

{$F+}

function detect_TSENG4000_256 : integer;
{
This a standard autodetect function as outlines in the Turbo Pascal Manual.
If the card is detected, a mode number is returned.
There does not seem to be a consistent way of determining which modes are
valid so we have choosen the 640x480 mode as a default. See the last few lines
of this routine to change the default mode.

If the card is  not found a negative number indicating an error is returned.


copyright(c) 1991 by Peter F. Jones. ALL RIGHTS RESERVED.
This software may be used and included in other programs as
outlined in your software license.
}
const copyrighttseng4000: string[60] = 'copyright(c) 1991 by Peter F. Jones. ALL RIGHTS RESERVED.';



var found : boolean;
    version: integer;
   graphdriver,graphmode: integer;
   old_extended_start_address,dummy_extended_start_address : byte;
begin

  detect_TSENG4000_256 := -11;   {return error if not found}

  graphdriver := 0;
  detectgraph(graphdriver,graphmode);
  found :=  graphdriver=VGA;



if found then
      begin
       port[$3d4] := $33;  {CRTC Extended Start Address index P130 of TSENG4000 manual}
       old_extended_start_address := port[$3d5];
       port[$3d5] := $0a;  {set it to 0a}
       dummy_extended_start_address := port[$3d5];
       dummy_extended_start_address :=   dummy_extended_start_address and $0f;
       found :=  dummy_extended_start_address = $0a;
      end;


if found then
      begin
       port[$3d5] := $05;  {set it to 05}
       dummy_extended_start_address := port[$3d5];
       dummy_extended_start_address :=   dummy_extended_start_address and $0f;
       found :=  dummy_extended_start_address = $05;
      end;

 if found then
      begin
       port[$3d5] := old_extended_start_address;
      end;

  if not found then exit;

  {*************************************************************************}
  {*************************************************************************}
  {*************************************************************************}
  {*************************************************************************}
  {Change the mode number on the next line to whatever you need as a default}

  detect_TSENG4000_256 := 3; {640x480 as default}

  {*************************************************************************}
  {*************************************************************************}
  {*************************************************************************}

  exit;


     end;
{$F-}


