/*	VGRX.c   routines to make it possible to do device independant
	         graphics. This isn't intended to be the last word on
	         the subject, it's just that I've already written the
	         code in PCX.C, and I'd like to now use it in PCXSHOW.c,
	         so why not set it up as a linkable library function!?
*/


#include <lib.h>
#include <vgr.h>


int	cga_init(), ega_init(), herc_init();


int vgr_setup( specifier )
char *specifier;
{
	vgr_type = vgr_get_board();

	if ( specifier )
	        if ( !strcmp(specifier, "ega") )
	           vgr_type = TYPE_EGA;
	   else if ( !strcmp(specifier, "cga") )
	           vgr_type = TYPE_CGA;
	   else if ( !strcmp(specifier, "herc") )
	           vgr_type = TYPE_HERC;
	   else if ( !strcmp(specifier, "cga2") )
	           vgr_type = 9;
	   else return ERROR;

	switch( vgr_type )
	{  case TYPE_UNKNOWN:
	   case TYPE_MDA:
	      return OK;
	   case TYPE_CGA:
	      vgr_type_name = "CGA/APA2";
	      vgr_nit = cga_init;
	      vgr_md = MODE_APA2;
	      vgr_hres = 640;
	      vgr_vres = 200;
	      vgr_planes = 1;
	      break;
	   case 9:
	      vgr_type_name = "CGA/APA3";
	      vgr_nit = cga_init;
	      vgr_md = MODE_APA3;
	      vgr_hres = 320;
	      vgr_vres = 200;
	      vgr_planes = 1;
	      break;
	   case TYPE_EGA:
	      vgr_type_name = "EGA";
	      vgr_nit = ega_init;
	      vgr_md = MODE_APA0;
	      vgr_hres = 640;
	      vgr_vres = 350;
	      vgr_planes = 4;
	      break;
	   case TYPE_HERC:
	      vgr_type_name = "HERC";
	      vgr_nit = herc_init;
	      vgr_md = MODE_APA1;
	      vgr_hres = 720;
	      vgr_vres = 348;
	      vgr_planes = 1;
	      break;
	   default:
	      return ERROR;
	};

	return OK;
}


